# Contributing to JOSESwift

Thanks for taking the time to contribute to the project.

:tada: First step done: All kinds of contributions are highly appreciated and very welcome.

## Code of Conduct

Everyone who participates in this project sticks to the [Code of Conduct](CODE_OF_CONDUCT.md). 

## I want to contribute, but how? 

For feature contributions or bug fixes, please submit a pull request. For feature requests, discussions or bug reports, just open an issue.

### Pull Request Process

1. If applicable, make sure your pull request includes tests that thoroughly cover newly added lines.
2. Please don’t forget to update the [README.md](../README.md) and other documentation with relevant details of changes.
3. Submit your pull request to `master`.
4. Provide a detailed description of your changes in the pull request description. Reference any resolved issues or previous discussions in other pull requests.
5. Pull requests will need to be approved before being merged. The better the pull request description, the easier and quicker a pull request will be to review.
6. Once approved, the pull request can be squash merged into master and we’re done. :tada:

### General

Please make sure to stick to general coding best practices and Swift code style as good as possible. You can find more info on that in GitHub’s [Swift Style Guide](https://github.com/github/swift-style-guide), the official Swift [API Design Guidelines](https://swift.org/documentation/api-design-guidelines/). 

Please also make sure that relevant code is documented and tested. :page_with_curl:

More information on how to create a pull request can be found in [this tutorial](https://help.github.com/articles/creating-a-pull-request-from-a-fork/). :mortar_board:

GitHub also has a nice blog post on [how to create the perfect pull request](https://github.com/blog/1943-how-to-write-the-perfect-pull-request). :sparkles:
